<?php
// Graphs Package V2.1 16th March 2008
// v2.2 - 8.1.2015 - uppdated data url
// v2.3 - 9.1.2015 - Corrected background image issue
//
//www.newquayweather.com/downloads.php
//
// produces a graph of mean sunspots since 1700
// data - Source: WDC-SILSO, Royal Observatory of Belgium, Brussels
// upload to sunspots-year-1700.php to wxgraphs and adjust paths
// for jpgraphs if different
// upload yearssn.txt to sunspots directory
// call using
// <img src="wxgraphs/sunspots-year1700.php" alt="Sunspots 1700"/>
//

// Settings
// Choose from one $bgimageurl background image or add or own
//  $bgimageurl="http://sohowww.nascom.nasa.gov/data/realtime/hmi_igr/512/latest.jpg"; // background MDI image to graphs
//  $bgimageurl="http://sohowww.nascom.nasa.gov/data/synoptic/sunspots_earth/mdi_sunspots.jpg"; // background image to graphs
//  $bgimageurl="http://sohowww.nascom.nasa.gov/data/realtime/hmi_mag/512/latest.jpg"; // HMI Magnetogram Image
  $bgimageurl="https://soho.nascom.nasa.gov/data/realtime/hmi_mag/512/latest.jpg"; // HMI Magnetogram Image 11-04-2022
// Change to fit your website
  $bgimage="/home/xxxxx/public_html/xxxxx/sunspots/bg1700image.jpg"; // background cache image path
  $refetchSeconds = 3600; // 1 hour
// end settings
  
if (!file_exists("graphsconf.php")) include("error_msg.php");
include ("graphsconf.php");
if (!file_exists($jploc."jpgraph.php")) {
  $string = "Unable to find JPGraph files";
  create_image1($string,$jploc);
  exit;
}
// background image
if (file_exists($bgimage) and filemtime($bgimage) + $refetchSeconds > time()) {
//      echo "<!-- using Cached version of jpg -->\n";
    } else {
$ch = curl_init($bgimageurl);
$fp = fopen($bgimage, 'wb');
curl_setopt($ch, CURLOPT_FILE, $fp);
curl_setopt($ch, CURLOPT_HEADER, 0);
curl_exec($ch);
curl_close($ch);
fclose($fp);
}
// end background image 	
include ($jploc."jpgraph.php");
include ($jploc."jpgraph_bar.php");
include ($jploc."jpgraph_line.php");

$aa=("${hostloc}sunspots/yearssn.txt");

$y = array();
$a = array();
readsunspotdata($aa,$a,$y);

// Here we create an aray for the y-values
//$y = array(fgets($handle[$yy]));
//=================================================================================================
//here we create the labels for the x-axis depending month and year
//so if we are in March we must show the last day of Feb normally 28 or 29 and the following
//label must be 01
//same for moths with 30 days (last day = 30 next label must be 01 and not 31
//we need 31 labels because we have 31 datapoints
//==================================================================================================
//
// Create the graph. These two calls are always required
$graph = new Graph(512,552,"auto",30);	
$graph->SetScale("textlin");
$graph->yscale->SetGrace(2);
$graph->SetMargin(35,25,15,55);
$graph->ygrid->Show(false); 
//$graph->SetShadow();  //uncomment to add shadow

// Graph colors
$graph->SetBackgroundGradient('black','black',GRAD_HOR,BGRAD_PLOT);
$graph->SetMarginColor('black');
$graph->SetFrame(true,'black',1);

// Create a bar pot
$lplot = new LinePlot($y);
$lplot->SetColor('orange'); // color of y-axis graph line
$lplot->SetWeight(2);
$graph->Add($lplot);
$graph->SetBackgroundImage($bgimage,BGIMG_FILLPLOT);

// Setup the titles
$graph->title->SetFont(FF_ARIAL,FS_BOLD,12);
$graph->title->Set("Sunspots - 1700 - 2014");
$graph->title->SetColor("orange"); 


//x-axis
$graph->xaxis->title->SetFont(FF_ARIAL,FS_BOLD,10);
$graph->xaxis->title->SetColor("$xtextcolour");
$graph->xaxis->SetTickLabels($a); 
$graph->xaxis->SetLabelAngle(80);
$graph->xaxis->SetLabelMargin(5); 
$graph->xaxis->SetTextLabelInterval(14);
$graph->xaxis->SetPos("min"); 
$graph->xaxis->SetFont(FF_ARIAL,FS_BOLD,12); 
$graph->xaxis->SetColor("$xtextcolour");
$graph->xaxis->HideTicks(true,false); 
$graph->xaxis->SetTickSide(SIDE_BOTTOM); 
$graph->xaxis->SetColor('white','orange'); 

//y-axis
$graph->yaxis->SetFont(FF_ARIAL,FS_BOLD,10);
$graph->yaxis->scale->SetGrace(5);
$graph->yaxis->SetLabelMargin(5); 
$graph->yaxis->SetColor('white','orange'); 

// Display the graph
$graph->Stroke();

function readsunspotdata($aFile, &$aYears, &$aSunspots) {
    $lines = @file($aFile,FILE_IGNORE_NEW_LINES|FILE_SKIP_EMPTY_LINES);
    if( $lines === false ) {
        throw new JpGraphException('Can not read sunspot data file.');
    }
    foreach( $lines as $line => $datarow ) {
        $split = preg_split('/[\s]+/',$datarow);
        $aYears[] = substr(trim($split[0]),0,4);
        $aSunspots[] = trim($split[1]);
    }
}

?>
